%global momorel 8

%global __libtoolize :
%global php_rrd_svn 839
%global php_extdir %(php-config --extension-dir 2>/dev/null || echo %{_libdir}/php4)
%global ruby_rrd_ver 1.1
%global ruby_libdir %(ruby -rrbconfig -e 'puts Config::CONFIG["rubylibdir"]')
%global ruby_archdir %(ruby -rrbconfig -e 'puts Config::CONFIG["archdir"]')
%global ruby_sitearchdir %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"]')

Summary: Round Robin Database Tool to store and display time-series data
Name: rrdtool
Version: 1.2.15
Release: %{momorel}m%{?dist}
License: GPL
Group: Applications/Databases
URL: http://oss.oetiker.ch/%{name}/
Source0: http://oss.oetiker.ch/%{name}/pub/%{name}-%{version}.tar.gz
NoSource: 0
Source1: php4-svn%{php_rrd_svn}.tar.gz
Source2: http://oss.oetiker.ch/%{name}/pub/contrib/ruby-rrd-%{ruby_rrd_ver}.tar.gz
Patch0: rrdtool-1.2.13-php.patch
Patch1: ruby-rrd-1.1-rrdtool-1.2.patch
Patch100: rrdtool-php-ppc64.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: gcc-c++, openssl-devel
BuildRequires: libpng-devel, zlib-devel, libart_lgpl-devel >= 2.0
BuildRequires: freetype-devel, python-devel >= 2.5

%global python_sitearch %(%{__python} -c 'from distutils import sysconfig; print sysconfig.get_python_lib(1)')
%global python_version %(%{__python} -c 'import sys; print sys.version.split(" ")[0]')

%description
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). It stores the data in a very compact way that will not
expand over time, and it presents useful graphs by processing the data to
enforce a certain data density. It can be used either via simple wrapper
scripts (from shell or Perl) or via frontends that poll network devices and
put a friendly user interface on it.

%package devel
Summary: RRDtool libraries and header files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). This package allow you to use directly this library.

%package doc
Summary: RRDtool documentation
Group: Documentation

%description doc
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). This package contains documentation on using RRD.

%package perl
Summary: Perl RRDtool bindings
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Obsoletes: perl-%{name} < %{version}-%{release}
Provides: perl-%{name} = %{version}-%{release}

%description perl
The Perl RRDtool bindings

%package python
Summary: Python RRDtool bindings
Group: Development/Languages
BuildRequires: python
Requires: python >= %{python_version}
Requires: %{name} = %{version}-%{release}
Obsoletes: python-%{name} < %{version}-%{release}
Provides: python-%{name} = %{version}-%{release}

%description python
Python RRDtool bindings.

%package php
Summary: PHP RRDtool bindings
Group: Development/Languages
BuildRequires: php-devel >= 4.0
Requires: php >= 4.0
Requires: %{name} = %{version}-%{release}
Obsoletes: php-%{name} < %{version}-%{release}
Provides: php-%{name} = %{version}-%{release}

%description php
The %{name}-php package includes a dynamic shared object (DSO) that adds
RRDtool bindings to the PHP HTML-embedded scripting language.

%package ruby
Summary: The extension library to use rrdtool from Ruby.
Group: Development/Languages
BuildRequires: ruby-devel
Requires: ruby
Requires: %{name} = %{version}-%{release}
Obsoletes: ruby-%{name} < %{version}-%{release}
Provides: ruby-%{name} = %{version}-%{release}

%description ruby
The extension library to use rrdtool from Ruby.

%prep
%setup -q
%setup -q -T -D -a 1 -a 2
# Patch based on http://oss.oetiker.ch/rrdtool/pub/contrib/php_rrdtool.tgz
%patch0 -p0 -b .php
%patch1 -p0 -b .ruby

%ifarch ppc64
%patch100 -p0 -b .ppc64
%endif

# Fix to find correct python dir on lib64
%{__perl} -pi -e 's|get_python_lib\(0,0,prefix|get_python_lib\(1,0,prefix|g' \
    configure

# Most edits shouldn't be necessary when using --libdir, but
# w/o, some introduce hardcoded rpaths where they shouldn't,
%{__perl} -pi.orig -e 's|/lib\b|/%{_lib}|g' \
    configure Makefile.in php4/configure php4/ltconfig*
cp -p %{_datadir}/libtool/config.{sub,guess} php4/

%build
%configure \
    --disable-static --disable-tcl \
    --with-pic \
    --with-perl-options='INSTALLDIRS="site"'

# Fix another rpath issue
%{__perl} -pi.orig -e 's|-Wl,--rpath -Wl,\$rp||g' \
    bindings/perl-shared/Makefile.PL

# Force RRDp bits where we want 'em, not sure yet why the
# --with-perl-options and --libdir don't take
pushd bindings/perl-piped/
%{__perl} Makefile.PL INSTALLDIRS=site
%{__perl} -pi.orig -e 's|/lib/perl|/%{_lib}/perl|g' Makefile
popd

%{__make} %{?_smp_mflags}

# Build the php module, the tmp install is required
%global rrdtmp %{_tmppath}/%{name}-%{version}-tmpinstall
%{__make} install DESTDIR="%{rrdtmp}" transform='s,x,x,'
pushd php4/
%configure \
    --with-rrdtool="%{rrdtmp}%{_prefix}" \
    --disable-static
%{__make} %{?_smp_mflags}
popd

# Fix @perl@ and @PERL@
find examples/ -type f \
    -exec %{__perl} -pi -e 's|^#! \@perl\@|#!%{__perl}|gi' {} \;
find examples/ -name "*.pl" \
    -exec %{__perl} -pi -e 's|\015||gi' {} \;

pushd ruby-rrd-%{ruby_rrd_ver}
ruby extconf.rb --with-opt-include=%{rrdtmp}%{_includedir} --with-opt-lib=%{rrdtmp}%{_libdir}
make
popd

%{__rm} -rf %{rrdtmp}

%install
rm -rf %{buildroot}
make DESTDIR="%{buildroot}" install transform='s,x,x,'

# Install the php module
%{__install} -D -m0755 php4/modules/rrdtool.so \
    %{buildroot}%{php_extdir}/rrdtool.so
# Clean up the examples for inclusion as docs
%{__rm} -rf php4/examples/.svn
# Put the php config bit into place
%{__mkdir_p} %{buildroot}%{_sysconfdir}/php.d
%{__cat} << __EOF__ > %{buildroot}%{_sysconfdir}/php.d/rrdtool.ini
; Enable rrdtool extension module
extension=rrdtool.so
__EOF__

# Pesky RRDp.pm...
%{__mv} %{buildroot}%{perl_sitearch}/../RRDp.pm %{buildroot}%{perl_sitearch}/

# We only want .txt and .html files for the main documentation
%{__mkdir_p} doc2/html doc2/txt
%{__cp} -a doc/*.txt doc2/txt/
%{__cp} -a doc/*.html doc2/html/

# Put perl docs in perl package
%{__mkdir_p} doc3/html
%{__mv} doc2/html/RRD*.html doc3/html/

# Clean up the examples
%{__rm} -f examples/Makefile* examples/*.in

# This is so rpm doesn't pick up perl module dependencies automatically
find examples/ -type f -exec chmod 0644 {} \;

# Clean up the buildroot
%{__rm} -rf %{buildroot}%{_datadir}/doc/%{name}-%{version}/{txt,html}/ \
	%{buildroot}%{perl_sitearch}/ntmake.pl \
	%{buildroot}%{perl_archlib}/perllocal.pod \
        %{buildroot}%{_datadir}/%{name}/examples \
        %{buildroot}%{perl_sitearch}/auto/*/{.packlist,*.bs}

pushd ruby-rrd-%{ruby_rrd_ver}
make install DESTDIR=%{buildroot}
popd

%clean
%{__rm} -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_bindir}/*
%{_libdir}/*.so.*
%{_datadir}/%{name}
%{_mandir}/man1/*

%files devel
%defattr(-,root,root,-)
%{_includedir}/*.h
%exclude %{_libdir}/*.la
%{_libdir}/*.so

%files doc
%defattr(-,root,root,-)
%doc CHANGES CONTRIBUTORS COPYING COPYRIGHT README TODO NEWS THREADS
%doc examples doc2/html doc2/txt

%files perl
%defattr(-,root,root,-)
%doc doc3/html
%{_mandir}/man3/*
%{perl_sitearch}/*.pm
%attr(0755,root,root) %{perl_sitearch}/auto/RRDs/

%files python
%defattr(-,root,root,-)
%doc bindings/python/AUTHORS bindings/python/COPYING bindings/python/README
%{python_sitearch}/rrdtoolmodule.so

%files php
%defattr(-,root,root,0755)
%doc php4/examples php4/README
%config(noreplace) %{_sysconfdir}/php.d/rrdtool.ini
%{php_extdir}/rrdtool.so

%files ruby
%defattr(-, root, root)
%doc ruby-rrd-%{ruby_rrd_ver}/{README,test.rb}
%{ruby_sitearchdir}/RRD.so

%changelog
* Mon Jun 18 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (1.2.15-8m)
- rebuild against ruby-1.8.6-4m

* Tue May  1 2007 zunda <zunda at freeshell.org>
- (1.2.15-7m)
- Updated URLs for the package, Source0, and Source2

* Sun Apr 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.2.15-6m)
- rebuild against php-5.2.1

* Sat Mar 31 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.2.15-5m)
- BuildRequires: freetype2-devel -> freetype-devel

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.2.15-4m)
- rebuild against python-2.5

* Wed Aug  9 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (1.2.15-3m)
- build fix for old env.

* Wed Aug  2 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.2.15-2m)
- merge rrdtool-ruby

* Mon Jul 24 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.2.15-1m)
- up to 1.2.15

* Wed Mar  8 2006 Mitsuru Shimamura <smbd@momonga-linux.org>
- (1.0.49-1m)
- up to 1.0.49
- change place for config file of php-rrdtool

* Thu Feb 9 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.0.48-10m)
- rebuild against perl-5.8.8

* Sun Jul  3 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.48-9m)
- fixed build error gcc4. add rrdtool-1.0.49-fc4.patch

* Mon Jun 13 2005 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.0.48-8m)
- rebuilt against perl-5.8.7

* Tue Apr  5 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (1.0.48-7m)
- rebuild against php-5.0.4

* Tue Feb 15 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (1.0.48-6m)
- phpextdir %%{_libdir}/php4 -> %%{_libdir}/php5
- enable x86_64.

* Sun Aug 22 2004 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.0.48-5m)
- build against perl-5.8.5

* Mon Jul 19 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.48-4m)
- add php-rrdtool

* Wed Jul 14 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.48-3m)
- noexec autoconf-1.7
- add transform='s,x,x,'

* Sun Jul 11 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (1.0.48-2m)
- remove Epoch from BuildPrereq

* Sat Jun 11 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.48-1m)
- verup

* Sat Mar 27 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.40-4m)
- revised spec for rpm 4.2.

* Sun Nov  9 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.40-3m)
- rebuild against perl-5.8.2

* Sun Nov  9 2003 Shigeyuki Yamashita <shige@momonga-linux.org>
- (1.0.40-2m)
- rebuild against perl-5.8.1

* Mon Nov 25 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.0.40-1m)
- rebuild against perl-5.8.0

* Fri Sep 13 2002 Shingo Akagaki <dora@kitty.dnsalias.org>
- (1.0.38-5m)
- add Provides: /usr/bin/rrdcgi

* Thu Aug  8 2002 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.38-4m)
- move site_perl directory [Momonga-devel.ja:00311] thanks Kyoichi Ozaki

* Wed Jul 31 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.0.38-3m)
- remove AutoReq: 0
- rrdtool-devel: Requires: %{name} = %{version}-%{release}
- rrdtool: Obsoletes: rrdtool-tcl

* Wed Jul 31 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.0.38-2m)
- use 'automake-old' instead of 'automake'

* Tue Jul 30 2002 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.38-1m)
- version up 1.0.38
- modified specfile

* Sun Apr 28 2002 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>
- (1.0.37-2k)
- chobitto syuusei

* Sun Apr 28 2002 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>
- (1.0.37-1k)
- up to 1.0.37
- irewasure
- brush up spec

* Tue Mar 12 2002 Masahiro Takahata <takahata@kondara.org>
- (1.0.34-2k)
- upgrade to 1.0.34-2k
- replaced zlib 1.1.3 with 1.1.4

* Mon Nov 19 2001 Masahiro Takahata <takahata@kondara.org>
- (1.0.33-2k)
- the first release
